﻿using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.IO;
using Crypto_Con_Client;
using System.Text;

namespace AES
{
    class AES
    {
        // Fields
    private static string _hash = "SHA512";
    private static int _iterations = 2;
    private static int _keySize = 256;
    private static string _salt;
    private static string _vector;
    private static string[] HashAlg = new string[] { "SHA1", "SHA256", "SHA384", "SHA512", "MD5", "RIPEMD160" };

    // Methods
    public static byte[] Decrypt(byte[] value, string password)
    {
        return Decrypt<AesManaged>(value, password);
    }

    public static byte[] Decrypt<T>(byte[] value, string password) where T: SymmetricAlgorithm, new()
    {
        byte[] buffer3;
        byte[] bytes = Encoding.ASCII.GetBytes(_vector);
        byte[] rgbSalt = Encoding.ASCII.GetBytes(_salt);
        int num = 0;
        using (T local = Activator.CreateInstance<T>())
        {
            byte[] rgbKey = new PasswordDeriveBytes(password, rgbSalt, _hash, _iterations).GetBytes(_keySize / 8);
            local.Mode = CipherMode.CBC;
            try
            {
                using (ICryptoTransform transform = local.CreateDecryptor(rgbKey, bytes))
                {
                    using (MemoryStream stream = new MemoryStream(value))
                    {
                        using (CryptoStream stream2 = new CryptoStream(stream, transform, CryptoStreamMode.Read))
                        {
                            buffer3 = new byte[value.Length];
                            num = stream2.Read(buffer3, 0, buffer3.Length);
                        }
                    }
                }
            }
            catch (Exception)
            {
                return null;
            }
            local.Clear();
        }
        return buffer3;
    }

    public static byte[] Encrypt(byte[] value, string password)
    {
        return Encrypt<AesManaged>(value, password);
    }

    public static byte[] Encrypt<T>(byte[] value, string password) where T: SymmetricAlgorithm, new()
    {
        byte[] buffer3;
        byte[] bytes = Encoding.ASCII.GetBytes(_vector);
        byte[] rgbSalt = Encoding.ASCII.GetBytes(_salt);
        using (T local = Activator.CreateInstance<T>())
        {
            byte[] rgbKey = new PasswordDeriveBytes(password, rgbSalt, _hash, _iterations).GetBytes(_keySize / 8);
            local.Mode = CipherMode.CBC;
            using (ICryptoTransform transform = local.CreateEncryptor(rgbKey, bytes))
            {
                using (MemoryStream stream = new MemoryStream())
                {
                    using (CryptoStream stream2 = new CryptoStream(stream, transform, CryptoStreamMode.Write))
                    {
                        stream2.Write(value, 0, value.Length);
                        stream2.FlushFinalBlock();
                        buffer3 = stream.ToArray();
                    }
                }
            }
            local.Clear();
        }
        return buffer3;
    }

    public static string GenerateRandomSalt(bool putdirectintovariabel)
    {
        if (putdirectintovariabel)
        {
            _salt = RandomString(0x10);
            return _salt;
        }
        return RandomString(0x10);
    }

    public static string GenerateRandomVector(bool putdirectintovariabel)
    {
        if (putdirectintovariabel)
        {
            _vector = RandomString(0x10);
            return _vector;
        }
        return RandomString(0x10);
    }

    private static int Prims(int etst)
    {
        int num3 = 0xf4240;
        string[] strArray = new string[num3];
        for (int i = 3; i < num3; i += 2)
        {
            int num2 = 3;
            while (num2 <= Math.Sqrt((double) i))
            {
                if ((i % num2) == 0)
                {
                    break;
                }
                num2 += 2;
            }
            if (((i % num2) != 0) && (i > etst))
            {
                return i;
            }
        }
        return 0;
    }

    private static string RandomString(int size)
    {
        return Random_Vector_Key_Salt.Generate(size);
    }

    // Properties
    public static string Hash
    {
        get
        {
            return _hash;
        }
        set
        {
            foreach (string str in HashAlg)
            {
                if (str == value)
                {
                    _hash = value;
                }
            }
        }
    }

    public static int Iterations
    {
        get
        {
            return _iterations;
        }
        set
        {
            _iterations = value;
        }
    }

    public static int KeySize
    {
        get
        {
            return _keySize;
        }
        set
        {
            _keySize = value;
        }
    }

    public static string Salt
    {
        get
        {
            return _salt;
        }
        set
        {
            _salt = value;
        }
    }

    public static string Vector
    {
        get
        {
            return _vector;
        }
        set
        {
            _vector = value;
        }
    }



    }
}
