﻿using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.IO;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace Crypto_Con_Client
{
    public static class Connection
    {
        public static string pw = null;
        public static AesManaged csEncrypt = null;
        private static ICryptoTransform transform;
        public static bool Connect(byte[] to_Encrypt, IPEndPoint ipe)
        {
            using (Socket s = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp))
            {
                s.Connect(ipe);
                using (NetworkStream ns = new NetworkStream(s))
                {
                    using (CryptoStream cs = new CryptoStream(ns, transform, CryptoStreamMode.Write))
                    {
                        cs.Write(to_Encrypt, 0, to_Encrypt.Length);
                        cs.FlushFinalBlock();
                    }
                    s.Disconnect(false);
                }
            }
            return true;
        }
        private static string _hash = "SHA512";
        private static int _iterations = 2;
        private static int _keySize = 256;
        private static string _salt;
        private static string _vector;
        private static string[] HashAlg = new string[] { "SHA1", "SHA256", "SHA384", "SHA512", "MD5", "RIPEMD160" };

        #region Decrypt_OLD
        //public static byte[] Decrypt(byte[] value, string password)
        //{
        //    byte[] buffer3;
        //    byte[] bytes = Encoding.ASCII.GetBytes(_vector);
        //    byte[] rgbSalt = Encoding.ASCII.GetBytes(_salt);
        //    int num = 0;
        //    csEncrypt = new AesManaged();
        //    byte[] rgbKey = new PasswordDeriveBytes(password, rgbSalt, _hash, _iterations).GetBytes(_keySize / 8);
        //    csEncrypt.Mode = CipherMode.CBC;
        //    try
        //    {
        //        using (ICryptoTransform transform = csEncrypt.CreateDecryptor(rgbKey, bytes))
        //        {
        //                using (MemoryStream stream = new MemoryStream(value))
        //                {
        //                    using (CryptoStream stream2 = new CryptoStream(stream, transform, CryptoStreamMode.Read))
        //                    {
        //                        buffer3 = new byte[value.Length];
        //                        num = stream2.Read(buffer3, 0, buffer3.Length);
        //                    }
        //                }
        //            }
        //        }
        //        catch (Exception)
        //        {
        //            return null;
        //        }
        //        csEncrypt.Clear();
        //    }
        //    return buffer3;
        //}
        #endregion
        public static bool Encrypt(string password)
        {
            
            bool error = false;
            try
            {
                byte[] bytes = Encoding.ASCII.GetBytes(_vector);
                byte[] rgbSalt = Encoding.ASCII.GetBytes(_salt);
                csEncrypt = new AesManaged();
                byte[] rgbKey = new PasswordDeriveBytes(password, rgbSalt, _hash, _iterations).GetBytes(_keySize / 8);
                csEncrypt.Mode = CipherMode.CBC;
                csEncrypt.Padding = PaddingMode.PKCS7;
                transform = csEncrypt.CreateEncryptor(rgbKey, bytes);
                csEncrypt.Clear();
            }
            catch (Exception ex)
            {
                error = false;
            }
            if (!error)
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        public static string GenerateRandomSalt(bool putdirectintovariabel)
        {
            if (putdirectintovariabel)
            {
                _salt = RandomString(0x10);
                return _salt;
            }
            return RandomString(0x10);
        }

        public static string GenerateRandomVector(bool putdirectintovariabel)
        {
            if (putdirectintovariabel)
            {
                _vector = RandomString(0x10);
                return _vector;
            }
            return RandomString(0x10);
        }

        private static int Prims(int etst)
        {
            int num3 = 0xf4240;
            string[] strArray = new string[num3];
            for (int i = 3; i < num3; i += 2)
            {
                int num2 = 3;
                while (num2 <= Math.Sqrt((double)i))
                {
                    if ((i % num2) == 0)
                    {
                        break;
                    }
                    num2 += 2;
                }
                if (((i % num2) != 0) && (i > etst))
                {
                    return i;
                }
            }
            return 0;
        }

        private static string RandomString(int size)
        {
            return Random_Vector_Key_Salt.Generate(size);
        }
    }
}
